2005-07-24 18:16:26 +00:00
#! /bin/sh
# Install GRUB on your drive.
2010-09-13 20:18:03 +00:00
# Copyright (C) 1999,2000,2001,2002,2003,2004,2005,2006,2007,2008,2009 Free Software Foundation, Inc.
2005-07-24 18:16:26 +00:00
#
2007-07-21 23:32:33 +00:00
# GRUB is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
2005-07-24 18:16:26 +00:00
# (at your option) any later version.
#
2007-07-21 23:32:33 +00:00
# GRUB is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
2005-07-24 18:16:26 +00:00
#
# You should have received a copy of the GNU General Public License
2007-07-21 23:32:33 +00:00
# along with GRUB. If not, see <http://www.gnu.org/licenses/>.
2005-07-24 18:16:26 +00:00
# Initialize some variables.
2007-04-10 21:38:26 +00:00
transform="@program_transform_name@"
2010-11-13 15:03:29 +00:00
prefix="@prefix@"
exec_prefix="@exec_prefix@"
2012-01-24 12:17:36 +00:00
datarootdir="@datarootdir@"
2010-11-13 15:03:29 +00:00
sbindir="@sbindir@"
bindir="@bindir@"
libdir="@libdir@"
sysconfdir="@sysconfdir@"
2005-07-24 18:16:26 +00:00
PACKAGE_NAME=@PACKAGE_NAME@
PACKAGE_TARNAME=@PACKAGE_TARNAME@
PACKAGE_VERSION=@PACKAGE_VERSION@
2012-02-29 23:40:02 +00:00
export TEXTDOMAIN=@PACKAGE@
export TEXTDOMAINDIR="@localedir@"
2009-12-24 22:23:22 +00:00
host_os=@host_os@
2012-02-27 15:06:18 +00:00
source_dir=
target=
2012-01-24 12:17:36 +00:00
datadir="@datadir@"
2012-02-10 17:16:27 +00:00
if [ "x$pkgdatadir" = x ]; then
2012-02-27 10:04:50 +00:00
pkgdatadir="${datadir}/@PACKAGE@"
2012-02-10 17:16:27 +00:00
fi
2010-11-13 15:03:29 +00:00
localedir="@datadir@/locale"
2005-07-24 18:16:26 +00:00
2010-11-13 15:03:29 +00:00
self="`basename $0`"
2010-06-08 10:52:42 +00:00
2010-11-13 15:03:29 +00:00
grub_mkimage="${bindir}/`echo grub-mkimage | sed ${transform}`"
grub_probe="${sbindir}/`echo grub-probe | sed ${transform}`"
grub_editenv="${bindir}/`echo grub-editenv | sed ${transform}`"
grub_mkrelpath="${bindir}/`echo grub-mkrelpath | sed ${transform}`"
2005-07-24 18:16:26 +00:00
rootdir=
2010-09-08 15:25:29 +00:00
bootdir=
2010-11-13 15:03:29 +00:00
grubdir="`echo "/@bootdirname@/@grubdirname@" | sed 's,//*,/,g'`"
2005-08-07 14:59:56 +00:00
modules=
2005-07-24 18:16:26 +00:00
install_device=
force_lba=
2011-12-24 12:37:28 +00:00
recheck=no
2005-07-24 18:16:26 +00:00
debug=no
2010-06-28 08:06:41 +00:00
debug_image=
2005-07-24 18:16:26 +00:00
2010-08-30 17:30:34 +00:00
update_nvram=yes
2010-08-30 19:00:48 +00:00
removable=no
efi_quiet=
2010-08-30 17:30:34 +00:00
2010-09-11 14:37:00 +00:00
# Get GRUB_DISTRIBUTOR.
2010-11-13 15:03:29 +00:00
if test -f "${sysconfdir}/default/grub" ; then
. "${sysconfdir}/default/grub"
2010-09-11 14:37:00 +00:00
fi
2011-02-09 11:23:11 +00:00
bootloader_id="$(echo "$GRUB_DISTRIBUTOR" | tr 'A-Z' 'a-z' | cut -d' ' -f1)"
2010-09-11 14:37:00 +00:00
if test -z "$bootloader_id"; then
bootloader_id=grub
fi
2012-02-27 15:06:18 +00:00
disk_module=unspecified
2009-06-08 20:51:16 +00:00
2012-02-10 17:16:27 +00:00
. "${pkgdatadir}/grub-mkconfig_lib"
2012-02-03 10:42:22 +00:00
2005-07-24 18:16:26 +00:00
# Usage: usage
# Print the usage.
usage () {
2012-03-05 15:42:26 +00:00
# TRANSLATORS: INSTALL_DEVICE isn't an identifier and is the DEVICE you
# install to.
2012-02-27 15:06:18 +00:00
gettext_printf "Usage: %s [OPTION] [INSTALL_DEVICE]" "$self"
2012-02-03 10:42:22 +00:00
echo
gettext "Install GRUB on your drive." ; echo
echo
2012-04-07 17:49:25 +00:00
print_option_help "-h, --help" "$(gettext "print this message and exit")"
print_option_help "-v, --version" "$(gettext "print the version information and exit")"
print_option_help "--modules=$(gettext "MODULES")" "$(gettext "pre-load specified modules MODULES")"
2012-02-27 15:06:18 +00:00
dirmsg="$(gettext_printf "install GRUB images under the directory DIR/%s instead of the %s directory" "@grubdirname@" "$grubdir")"
2012-04-07 17:49:25 +00:00
print_option_help "--boot-directory=$(gettext "DIR")" "$dirmsg"
2012-03-02 20:08:38 +00:00
# TRANSLATORS: "TARGET" as in "target platform".
2012-03-02 10:53:50 +00:00
target_trans="$(gettext "TARGET")"
# TRANSLATORS: "current" refers to the platform user's currently running on
2012-04-07 17:49:25 +00:00
print_option_help "--target=$target_trans" "$(gettext "install GRUB for TARGET platform [default=current]")"
print_option_help "--directory=$(gettext "DIR")" "$(gettext "use GRUB images from DIR. Takes precedence over target")"
print_option_help "--grub-setup=$(gettext "FILE")" "$(gettext "use FILE as grub-setup")"
print_option_help "--grub-mkimage=$(gettext "FILE")" "$(gettext "use FILE as grub-mkimage")"
print_option_help "--grub-mkrelpath=$(gettext "FILE")" "$(gettext "use FILE as grub-mkrelpath")"
print_option_help "--grub-probe=$(gettext "FILE")" "$(gettext "use FILE as grub-probe")"
2012-03-06 13:11:10 +00:00
# TRANSLATORS: "may break" doesn't just mean that option wouldn't have any
# effect but that it will make the resulting install unbootable from HDD.
2012-04-07 17:49:25 +00:00
print_option_help "--allow-floppy" "$(gettext "make the drive also bootable as floppy (default for fdX devices). May break on some BIOSes.")"
print_option_help "--recheck" "$(gettext "delete device map if it already exists")"
print_option_help "--force" "$(gettext "install even if problems are detected")"
print_option_help "--force-file-id" "$(gettext "use identifier file even if UUID is available")"
print_option_help "--disk-module=$(gettext "MODULE")" "$(gettext "disk module to use (biosdisk or native). This option is only available on BIOS target.")"
print_option_help "--no-nvram" "$(gettext "don't update the \`boot-device' NVRAM variable. This option is only available on IEEE1275 targets.")"
print_option_help "--removable" "$(gettext "the installation device is removable. This option is only available on EFI.")"
print_option_help "--bootloader-id=$(gettext "ID")" "$(gettext "the ID of bootloader. This option is only available on EFI.")"
2012-04-18 20:43:55 +00:00
print_option_help "--efi-directory=$(gettext "DIR")" "$(gettext "use DIR as the EFI System Partition root.")"
2012-02-03 10:42:22 +00:00
echo
gettext "INSTALL_DEVICE must be system device filename.";echo
echo
gettext_printf "%s copies GRUB images into %s, and uses grub-setup
to install grub into the boot sector.\n" "$self" "$grubdir";echo
echo
gettext "Report bugs to <bug-grub@gnu.org>."; echo
2005-07-24 18:16:26 +00:00
}
2010-04-12 16:03:03 +00:00
argument () {
2010-11-13 15:03:29 +00:00
opt="$1"
2010-04-12 16:03:03 +00:00
shift
if test $# -eq 0; then
2012-03-05 15:37:29 +00:00
gettext_printf "%s: option requires an argument -- \`%s'\n" "$0" "$opt" 1>&2
2010-04-12 16:03:03 +00:00
exit 1
fi
2010-11-13 15:03:29 +00:00
echo "$1"
2010-04-12 16:03:03 +00:00
}
2010-10-16 22:35:14 +00:00
allow_floppy=""
2012-02-27 01:23:14 +00:00
force_file_id=
2012-04-18 20:43:55 +00:00
efidir=
2010-10-16 22:35:14 +00:00
2005-07-24 18:16:26 +00:00
# Check the arguments.
2010-02-06 08:59:42 +00:00
while test $# -gt 0
do
option=$1
shift
2005-07-24 18:16:26 +00:00
case "$option" in
-h | --help)
usage
exit 0 ;;
-v | --version)
2010-06-08 10:52:42 +00:00
echo "$self (${PACKAGE_NAME}) ${PACKAGE_VERSION}"
2005-07-24 18:16:26 +00:00
exit 0 ;;
2010-02-06 08:59:42 +00:00
--modules)
2010-04-12 16:03:03 +00:00
modules=`argument $option "$@"`; shift;;
2005-08-07 14:59:56 +00:00
--modules=*)
modules=`echo "$option" | sed 's/--modules=//'` ;;
2010-02-06 08:59:42 +00:00
2012-02-27 01:23:14 +00:00
--force-file-id)
force_file_id=y ;;
2010-08-30 17:48:10 +00:00
# Accept and ignore for compatibility
2010-02-06 08:59:42 +00:00
--font)
2010-08-30 17:48:10 +00:00
shift;;
2009-12-09 18:39:21 +00:00
--font=*)
2010-08-30 17:48:10 +00:00
;;
2010-02-06 08:59:42 +00:00
2010-09-08 15:25:29 +00:00
# Accept for compatibility
2010-02-06 08:59:42 +00:00
--root-directory)
2010-11-13 15:03:29 +00:00
rootdir="`argument $option "$@"`"; shift;;
2005-07-24 18:16:26 +00:00
--root-directory=*)
2010-11-13 15:03:29 +00:00
rootdir="`echo "$option" | sed 's/--root-directory=//'`" ;;
2010-02-06 08:59:42 +00:00
2010-09-08 15:25:29 +00:00
--boot-directory)
2010-11-13 15:03:29 +00:00
bootdir="`argument $option "$@"`"; shift;;
2010-09-08 15:25:29 +00:00
--boot-directory=*)
2010-11-13 15:03:29 +00:00
bootdir="`echo "$option" | sed 's/--boot-directory=//'`" ;;
2010-09-08 15:25:29 +00:00
2012-04-18 20:43:55 +00:00
--efi-directory)
efidir="`argument $option "$@"`"; shift;;
--efi-directory=*)
efidir="`echo "$option" | sed 's/--efi-directory=//'`" ;;
2012-02-27 15:06:18 +00:00
--directory | -d)
source_dir="`argument $option "$@"`"; shift;;
--directory=*)
source_dir="`echo "$option" | sed 's/--directory=//'`" ;;
--target)
target="`argument $option "$@"`"; shift;;
--target=*)
target="`echo "$option" | sed 's/--target=//'`" ;;
2010-02-06 08:59:42 +00:00
--grub-setup)
2010-11-13 15:03:29 +00:00
grub_setup="`argument "$option" "$@"`"; shift;;
2005-07-24 18:16:26 +00:00
--grub-setup=*)
2010-11-13 15:03:29 +00:00
grub_setup="`echo "$option" | sed 's/--grub-setup=//'`" ;;
2010-02-06 08:59:42 +00:00
2010-09-11 14:37:00 +00:00
--bootloader-id)
2010-11-13 15:03:29 +00:00
bootloader_id="`argument $option "$@"`"; shift;;
2010-09-21 11:10:36 +00:00
--bootloader-id=*)
2010-11-13 15:03:29 +00:00
bootloader_id="`echo "$option" | sed 's/--bootloader-id=//'`" ;;
2010-09-11 14:37:00 +00:00
2010-02-06 08:59:42 +00:00
--grub-mkimage)
2010-11-13 15:03:29 +00:00
grub_mkimage="`argument $option "$@"`"; shift;;
2005-07-24 18:16:26 +00:00
--grub-mkimage=*)
2010-11-13 15:03:29 +00:00
grub_mkimage="`echo "$option" | sed 's/--grub-mkimage=//'`" ;;
2010-02-06 08:59:42 +00:00
2010-08-30 17:30:34 +00:00
--grub-mkrelpath)
2010-11-13 15:03:29 +00:00
grub_mkrelpath="`argument "$option" "$@"`"; shift;;
2010-11-22 13:57:16 +00:00
--grub-mkrelpath=*)
2010-11-13 15:03:29 +00:00
grub_mkrelpath="`echo "$option" | sed 's/--grub-mkrelpath=//'`" ;;
2010-08-30 17:30:34 +00:00
2012-02-03 21:36:51 +00:00
# Ignore: for compatibility
2010-02-06 08:59:42 +00:00
--grub-mkdevicemap)
2012-02-03 21:36:51 +00:00
shift;;
2005-07-24 18:16:26 +00:00
--grub-mkdevicemap=*)
2012-02-03 21:36:51 +00:00
;;
2010-02-06 08:59:42 +00:00
--grub-probe)
2010-11-13 15:03:29 +00:00
grub_probe="`argument "$option" "$@"`"; shift;;
2006-10-14 18:59:34 +00:00
--grub-probe=*)
2010-11-13 15:03:29 +00:00
grub_probe="`echo "$option" | sed 's/--grub-probe=//'`" ;;
2010-02-06 08:59:42 +00:00
2005-07-24 18:16:26 +00:00
--no-floppy)
2012-02-08 18:26:01 +00:00
;;
2005-07-24 18:16:26 +00:00
--recheck)
2011-12-24 12:37:28 +00:00
recheck=yes ;;
2010-08-30 19:00:48 +00:00
--removable)
removable=yes ;;
2010-02-06 08:59:42 +00:00
2010-10-16 22:35:14 +00:00
--allow-floppy)
allow_floppy="--allow-floppy" ;;
2010-02-06 08:59:42 +00:00
--disk-module)
2012-02-27 15:06:18 +00:00
disk_module="`argument "$option" "$@"`"; shift;
;;
2009-06-08 20:51:16 +00:00
--disk-module=*)
2012-02-27 15:06:18 +00:00
disk_module="`echo "$option" | sed 's/--disk-module=//'`"
;;
2010-02-06 08:59:42 +00:00
2010-08-30 17:30:34 +00:00
--no-nvram)
update_nvram=no ;;
2005-07-24 18:16:26 +00:00
# This is an undocumented feature...
--debug)
debug=yes ;;
2010-06-28 08:06:41 +00:00
--debug-image)
2010-11-13 15:03:29 +00:00
debug_image="`argument "$option" "$@"`"; shift;;
2010-06-28 08:06:41 +00:00
--debug-image=*)
2010-11-13 15:03:29 +00:00
debug_image="`echo "$option" | sed 's/--debug-image=//'`" ;;
2010-06-28 08:06:41 +00:00
2009-05-04 16:16:03 +00:00
-f | --force)
setup_force="--force" ;;
2010-02-06 08:59:42 +00:00
2005-07-24 18:16:26 +00:00
-*)
2012-02-03 21:52:23 +00:00
gettext_printf "Unrecognized option \`%s'\n" "$option" 1>&2
2005-07-24 18:16:26 +00:00
usage
exit 1
;;
*)
if test "x$install_device" != x; then
2012-02-26 16:28:05 +00:00
gettext "More than one install device?" 1>&2
2012-02-03 21:52:23 +00:00
echo 1>&2
2005-07-24 18:16:26 +00:00
usage
exit 1
fi
install_device="${option}" ;;
esac
done
2012-02-27 15:06:18 +00:00
if [ x$source_dir = x ]; then
if [ x$target = x ]; then
case x"`uname -m`" in
x"powerpc"* | x"ppc"*)
target="powerpc-ieee1275";;
x"sparc"*)
target="sparc64-ieee1275";;
x"mips"*"el")
target="mipsel-loongson";;
x"mips"*)
target="mips-arc";;
x"ia64"*)
target="ia64-efi";;
x"x86_64"* | x"amd64"*)
2012-03-03 22:15:18 +00:00
# On Linux, we need the efivars kernel modules.
# If no EFI is available this module just does nothing
# besides a small hello and if we detect efi we'll load it
# anyway later. So it should be safe to
# try to load it here.
case "$host_os" in
linux*)
modprobe -q efivars 2>/dev/null || true ;;
esac
2012-02-27 15:06:18 +00:00
if [ -d /sys/firmware/efi ]; then
target="x86_64-efi"
fi
target=i386-pc;;
x"i"?"86"*)
2012-03-03 22:15:18 +00:00
# On Linux, we need the efivars kernel modules.
# If no EFI is available this module just does nothing
# besides a small hello and if we detect efi we'll load it
# anyway later. So it should be safe to
# try to load it here.
case "$host_os" in
linux*)
modprobe -q efivars 2>/dev/null || true ;;
esac
2012-02-27 15:06:18 +00:00
if [ -d /sys/firmware/efi ]; then
target="i386-efi"
fi
if [ -e /proc/device-tree ]; then
target="i386-ieee1275"
fi
target=i386-pc;;
*)
gettext "Unable to determine your platform. Use --target." ;
echo ;;
esac
fi
source_dir="${libdir}/@PACKAGE@/$target"
fi
2012-02-27 20:31:58 +00:00
if ! [ -d "$source_dir" ]; then
gettext_printf "%s doesn't exist. Please specify --target or --directory\\n" "source_dir"
2012-02-27 15:06:18 +00:00
exit 1
fi
. "${source_dir}"/modinfo.sh
if [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "i386-pc" ] ; then
if [ x$disk_module = xunspecified ]; then
disk_module=biosdisk
fi
elif [ "${grub_modinfo_platform}" = "ieee1275" ] || [ "${grub_modinfo_platform}" = "efi" ] ; then
disk_module=
else
disk_module=native
fi
if test "x$grub_setup" = x && [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "i386-pc" ]; then
2012-02-27 13:24:22 +00:00
grub_setup="${sbindir}/`echo grub-bios-setup | sed ${transform}`"
fi
2012-02-27 15:06:18 +00:00
if test "x$grub_setup" = x && [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "sparc64-ieee1275" ]; then
2012-02-27 13:24:22 +00:00
grub_setup="${sbindir}/`echo grub-sparc64-setup | sed ${transform}`"
fi
2012-02-27 15:06:18 +00:00
if test "x$install_device" = x && ([ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "i386-pc" ] \
|| [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "sparc64-ieee1275" ]); then
2012-02-03 21:52:23 +00:00
gettext "Install device isn't specified." 1>&2
echo 1>&2
2005-07-24 18:16:26 +00:00
usage
exit 1
fi
2012-02-27 15:06:18 +00:00
if ! ([ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "i386-pc" ] \
|| [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "sparc64-ieee1275" ] \
|| [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "powerpc-ieee1275" ] \
|| [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "mips-arc" ]); then
2011-01-22 14:10:29 +00:00
install_device=
fi
2005-07-24 18:16:26 +00:00
# If the debugging feature is enabled, print commands.
2008-07-24 19:02:47 +00:00
setup_verbose=
2010-11-13 15:03:29 +00:00
if test x"$debug" = xyes; then
2005-07-24 18:16:26 +00:00
set -x
2008-07-24 19:02:47 +00:00
setup_verbose="--verbose"
2010-08-30 19:00:48 +00:00
efi_quiet=-q
2005-07-24 18:16:26 +00:00
fi
2010-09-08 15:25:29 +00:00
if [ -z "$bootdir" ]; then
# Default bootdir if bootdir not initialized.
2010-11-13 15:03:29 +00:00
bootdir="/@bootdirname@"
2005-07-24 18:16:26 +00:00
2010-09-08 15:25:29 +00:00
if [ -n "$rootdir" ] ; then
# Initialize bootdir if rootdir was initialized.
2010-11-13 15:03:29 +00:00
bootdir="${rootdir}/@bootdirname@"
2010-09-08 15:25:29 +00:00
fi
fi
2005-07-24 18:16:26 +00:00
2010-11-13 15:03:29 +00:00
grubdir="`echo "${bootdir}/@grubdirname@" | sed 's,//*,/,g'`"
device_map="${grubdir}/device.map"
2008-06-06 15:49:23 +00:00
2005-07-24 18:16:26 +00:00
# Check if GRUB is installed.
2012-02-27 15:06:18 +00:00
if [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "i386-pc" ] || [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "sparc64-ieee1275" ] ; then
2008-11-28 20:06:55 +00:00
set $grub_setup dummy
if test -f "$1"; then
:
else
echo "$1: Not found." 1>&2
exit 1
fi
2005-07-24 18:16:26 +00:00
fi
2010-11-13 15:03:29 +00:00
set "$grub_mkimage" dummy
2005-07-24 18:16:26 +00:00
if test -f "$1"; then
:
else
echo "$1: Not found." 1>&2
exit 1
fi
2012-02-27 15:06:18 +00:00
if [ x"$grub_modinfo_platform" = xefi ]; then
2010-09-08 11:54:38 +00:00
# Find the EFI System Partition.
2012-04-18 20:43:55 +00:00
if test -n "$efidir"; then
install_device="`"$grub_probe" --target=device --device-map= "${efidir}"`"
else
if test -d "${bootdir}/efi"; then
install_device="`"$grub_probe" --target=device --device-map= "${bootdir}/efi"`"
# Is it a mount point?
if test "x$install_device" != "x`"$grub_probe" --target=device --device-map= "${bootdir}"`"; then
efidir="${bootdir}/efi"
fi
elif test -d "${bootdir}/EFI"; then
install_device="`"$grub_probe" --target=device --device-map= "${bootdir}/EFI"`"
# Is it a mount point?
if test "x$install_device" != "x`"$grub_probe" --target=device --device-map= "${bootdir}"`"; then
efidir="${bootdir}/EFI"
fi
elif test -n "$rootdir" && test "x$rootdir" != "x/"; then
2010-09-08 11:54:38 +00:00
# The EFI System Partition may have been given directly using
# --root-directory.
2012-04-18 20:43:55 +00:00
install_device="`"$grub_probe" --target=device --device-map= "${rootdir}"`"
2010-09-08 11:54:38 +00:00
# Is it a mount point?
2012-04-18 20:43:55 +00:00
if test "x$install_device" != "x`"$grub_probe" --target=device --device-map= "${rootdir}/.."`"; then
efidir="${rootdir}"
fi
2010-09-08 11:54:38 +00:00
fi
2012-04-18 20:43:55 +00:00
if test -n "$efidir"; then
efi_fs=`"$grub_probe" --target=fs "--device-map=${device_map}" "${efidir}"`
if test "x$efi_fs" = xfat; then :; else
gettext_printf "%s doesn't look like an EFI partition.\n" "${efidir}" 1>&2
efidir=
fi
2010-09-08 11:54:38 +00:00
fi
fi
2012-04-18 20:43:55 +00:00
2010-09-08 11:54:38 +00:00
if test -n "$efidir"; then
# The EFI specification requires that an EFI System Partition must
# contain an "EFI" subdirectory, and that OS loaders are stored in
# subdirectories below EFI. Vendors are expected to pick names that do
# not collide with other vendors. To minimise collisions, we use the
# name of our distributor if possible.
2010-09-11 14:37:00 +00:00
efi_distributor="$bootloader_id"
2010-09-08 11:54:38 +00:00
if test $removable = yes; then
# The specification makes stricter requirements of removable
# devices, in order that only one image can be automatically loaded
# from them. The image must always reside under /EFI/BOOT, and it
# must have a specific file name depending on the architecture.
efi_distributor=BOOT
2012-02-27 15:06:18 +00:00
case "$grub_modinfo_target_cpu" in
2010-09-08 11:54:38 +00:00
i386)
efi_file=BOOTIA32.EFI ;;
2011-03-23 10:52:04 +00:00
x86_64)
2010-09-08 11:54:38 +00:00
efi_file=BOOTX64.EFI ;;
# GRUB does not yet support these architectures, but they're defined
# by the specification so we include them here to ease future
# expansion.
ia64)
efi_file=BOOTIA64.EFI ;;
esac
else
# It is convenient for each architecture to have a different
# efi_file, so that different versions can be installed in parallel.
2012-02-27 15:06:18 +00:00
case "$grub_modinfo_target_cpu" in
2010-09-08 11:54:38 +00:00
i386)
efi_file=grubia32.efi ;;
2011-03-23 10:52:04 +00:00
x86_64)
2010-09-08 11:54:38 +00:00
efi_file=grubx64.efi ;;
# GRUB does not yet support these architectures, but they're defined
# by the specification so we include them here to ease future
# expansion.
ia64)
efi_file=grubia64.efi ;;
*)
efi_file=grub.efi ;;
esac
# TODO: We should also use efibootmgr, if available, to add a Boot
# entry for ourselves.
fi
efidir="$efidir/EFI/$efi_distributor"
mkdir -p "$efidir" || exit 1
else
# We don't know what's going on. Fall back to traditional
# (non-specification-compliant) behaviour.
efidir="$grubdir"
efi_distributor=
efi_file=grub.efi
fi
fi
2005-07-24 18:16:26 +00:00
# Create the GRUB directory if it is not present.
2010-04-03 18:48:36 +00:00
mkdir -p "$grubdir" || exit 1
2012-02-27 15:06:18 +00:00
mkdir -p "$grubdir/${grub_modinfo_target_cpu}-$grub_modinfo_platform" || exit 1
2005-07-24 18:16:26 +00:00
2011-12-24 12:37:28 +00:00
# If --recheck is specified, remove the device map, if present.
if test $recheck = yes; then
rm -f "$device_map"
fi
2005-07-24 18:16:26 +00:00
# Create the device map file if it is not present.
if test -f "$device_map"; then
2011-12-23 17:19:16 +00:00
# Make sure that there is no duplicated entry.
tmp=`sed -n '/^([fh]d[0-9]*)/s/\(^(.*)\).*/\1/p' "$device_map" \
| sort | uniq -d | sed -n 1p`
if test -n "$tmp"; then
2012-02-03 21:52:23 +00:00
gettext_printf "The drive %s is defined multiple times in the device map %s\n" "$tmp" "$device_map" 1>&2
2011-12-23 17:19:16 +00:00
exit 1
fi
2005-07-24 18:16:26 +00:00
else
2011-12-23 17:19:16 +00:00
device_map=
2005-07-24 18:16:26 +00:00
fi
# Copy the GRUB images to the GRUB directory.
2012-02-27 15:06:18 +00:00
for file in "${grubdir}"/*.mod "${grubdir}"/*.lst "${grubdir}"/*.img "${grubdir}"/efiemu??.o "${grubdir}"/${grub_modinfo_target_cpu}-$grub_modinfo_platform/*.mod "${grubdir}"/${grub_modinfo_target_cpu}-$grub_modinfo_platform/*.lst "${grubdir}"/${grub_modinfo_target_cpu}-$grub_modinfo_platform/*.img "${grubdir}"/${grub_modinfo_target_cpu}-$grub_modinfo_platform/efiemu??.o; do
2010-11-13 15:03:29 +00:00
if test -f "$file" && [ "`basename $file`" != menu.lst ]; then
rm -f "$file" || exit 1
2005-07-24 18:16:26 +00:00
fi
done
2012-02-27 15:06:18 +00:00
for file in "${source_dir}"/*.mod "${source_dir}"/*.lst; do
cp -f "$file" "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform" || exit 1
2005-07-24 18:16:26 +00:00
done
2012-02-27 15:06:18 +00:00
if [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "i386-pc" ] || [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "sparc64-ieee1275" ] ; then
for file in "${source_dir}"/*.img "${source_dir}"/efiemu??.o; do
2010-11-13 15:03:29 +00:00
if test -f "$file"; then
2012-02-27 15:06:18 +00:00
cp -f "$file" "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform" || exit 1
2009-05-03 19:04:59 +00:00
fi
2008-11-28 20:06:55 +00:00
done
fi
2005-07-24 18:16:26 +00:00
2009-12-05 09:31:36 +00:00
# Copy gettext files
2010-11-13 15:03:29 +00:00
mkdir -p "${grubdir}"/locale/
for dir in "${localedir}"/*; do
2010-03-21 23:04:02 +00:00
if test -f "$dir/LC_MESSAGES/grub.mo"; then
cp -f "$dir/LC_MESSAGES/grub.mo" "${grubdir}/locale/${dir##*/}.mo"
2009-12-05 09:31:36 +00:00
fi
done
2012-03-10 11:33:52 +00:00
if test -f "${pkgdatadir}"/themes/starfield/theme.txt; then
2012-02-23 16:21:38 +00:00
mkdir -p "${grubdir}"/themes/starfield
cp "${pkgdatadir}"/themes/starfield/* "${grubdir}"/themes/starfield
fi
2012-02-24 10:18:06 +00:00
if test -f "${pkgdatadir}"/unicode.pf2; then
mkdir -p "${grubdir}"/fonts
cp "${pkgdatadir}"/unicode.pf2 "${grubdir}"/fonts
fi
2012-03-08 23:56:22 +00:00
if ! is_path_readable_by_grub "${grubdir}"; then
gettext_printf "Path \`%s' is not readable by GRUB on boot. Installation is impossible. Aborting.\n" "${grubdir}" 1>&2
exit 1
fi
2011-04-22 22:13:56 +00:00
2008-06-06 15:49:23 +00:00
# Write device to a variable so we don't have to traverse /dev every time.
2010-11-13 15:03:29 +00:00
grub_device="`"$grub_probe" --device-map="${device_map}" --target=device "${grubdir}"`" || exit 1
2008-06-06 15:49:23 +00:00
2010-11-13 15:03:29 +00:00
if ! test -f "${grubdir}"/grubenv; then
"$grub_editenv" "${grubdir}"/grubenv create
2009-11-20 08:41:20 +00:00
fi
2006-09-14 18:52:50 +00:00
# Create the core image. First, auto-detect the filesystem module.
2012-02-03 09:35:28 +00:00
fs_module="`echo "${grub_device}" | xargs "$grub_probe" --device-map="${device_map}" --target=fs --device `"
2010-11-06 20:37:13 +00:00
if test "x$fs_module" = x ; then
2012-02-03 21:52:23 +00:00
gettext_printf "Auto-detection of a filesystem of %s failed.\n" "${grub_device}" 1>&2
gettext "Try with --recheck." 1>&2
echo 1>&2
gettext_printf "If the problem persists please report this together with the output of %s to <%s>" "\"$grub_probe --device-map=\"${device_map}\" --target=fs -v ${grubdir}\"" "bug-grub@gnu.org" 1>&2
2005-08-07 14:59:56 +00:00
exit 1
fi
2007-07-02 13:58:03 +00:00
# Then the partition map module. In order to support partition-less media,
2010-09-13 20:18:03 +00:00
# this command is allowed to fail (--target=fs already grants us that the
# filesystem will be accessible).
2010-02-06 18:33:53 +00:00
partmap_module=
2012-02-03 09:35:28 +00:00
for x in `echo "${grub_device}" | xargs "$grub_probe" --device-map="${device_map}" --target=partmap --device 2> /dev/null`; do
2010-09-03 23:19:11 +00:00
case "$x" in
netbsd | openbsd)
partmap_module="$partmap_module part_bsd";;
2010-11-14 15:15:41 +00:00
"") ;;
2010-09-03 23:19:11 +00:00
*)
partmap_module="$partmap_module part_$x";;
esac
2010-02-06 18:33:53 +00:00
done
2007-05-07 19:54:46 +00:00
2008-01-12 15:11:57 +00:00
# Device abstraction module, if any (lvm, raid).
2012-02-03 09:35:28 +00:00
devabstraction_module="`echo "${grub_device}" | xargs "$grub_probe" --device-map="${device_map}" --target=abstraction --device`"
2008-01-12 15:11:57 +00:00
2010-12-25 11:11:54 +00:00
if [ "x$disk_module" = xata ]; then
disk_module=pata
fi
if [ "x$disk_module" = xnative ]; then
2011-07-25 06:06:20 +00:00
disk_module="pata ahci ohci"
2012-02-27 15:06:18 +00:00
if [ "x$grub_modinfo_target_cpu" = "xi386" ] || [ "x$grub_modinfo_target_cpu" = "xx86_64" ]; then
2011-07-25 06:06:20 +00:00
disk_module="$disk_module uhci"
fi
disk_module="$disk_module usbms"
2010-12-25 11:11:54 +00:00
fi
2008-07-30 10:44:38 +00:00
# The order in this list is critical. Be careful when modifying it.
2009-06-08 20:51:16 +00:00
modules="$modules $disk_module"
2008-11-28 20:06:55 +00:00
modules="$modules $fs_module $partmap_module $devabstraction_module"
2008-07-30 10:44:38 +00:00
2010-11-13 15:03:29 +00:00
relative_grubdir="`"$grub_mkrelpath" "${grubdir}"`" || exit 1
2009-11-25 21:34:35 +00:00
if [ "x${relative_grubdir}" = "x" ] ; then
relative_grubdir=/
fi
2008-07-30 10:44:38 +00:00
prefix_drive=
2009-11-25 21:34:35 +00:00
config_opt=
2012-02-27 15:06:18 +00:00
rm -f "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/load.cfg"
2010-06-28 08:06:41 +00:00
if [ "x${debug_image}" != x ]; then
2012-02-27 15:06:18 +00:00
echo "set debug='${debug_image}'" >> "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/load.cfg"
config_opt="-c ${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/load.cfg "
2010-06-28 08:06:41 +00:00
fi
2008-06-18 17:35:26 +00:00
if [ "x${devabstraction_module}" = "x" ] ; then
2009-12-09 18:39:21 +00:00
if [ x"${install_device}" != x ]; then
if echo "${install_device}" | grep -qx "(.*)" ; then
install_drive="${install_device}"
else
2010-11-13 15:03:29 +00:00
install_drive="`"$grub_probe" --device-map="${device_map}" --target=drive --device "${install_device}"`" || exit 1
2009-12-09 18:39:21 +00:00
fi
2011-12-24 01:50:30 +00:00
install_drive="`echo "${install_drive}" | sed -e 's/^(\(\([^,\\\\]\|\\\\\\\\\|\\\\,\)*\)\(\(,[a-zA-Z0-9]*\)*\))$/\1/'`"
2008-07-30 10:44:38 +00:00
fi
2012-02-03 09:35:28 +00:00
grub_drive="`echo "${grub_device}" | xargs "$grub_probe" --device-map="${device_map}" --target=drive --device`" || exit 1
2008-07-30 10:44:38 +00:00
# Strip partition number
2011-12-24 01:50:30 +00:00
grub_partition="`echo "${grub_drive}" | sed -e 's/^(\(\([^,\\\\]\|\\\\\\\\\|\\\\,\)*\)\(\(,[a-zA-Z0-9]*\)*\))$/\3/'`"
grub_drive="`echo "${grub_drive}" | sed -e 's/^(\(\([^,\\\\]\|\\\\\\\\\|\\\\,\)*\)\(\(,[a-zA-Z0-9]*\)*\))$/\1/'`"
2012-02-27 15:06:18 +00:00
if ([ "x$disk_module" != x ] && [ "x$disk_module" != xbiosdisk ]) || [ "x${grub_drive}" != "x${install_drive}" ] || ([ "x$grub_modinfo_platform" != xefi ] && [ "x$grub_modinfo_platform" != xpc ] && [ x"${grub_modinfo_platform}" != x"ieee1275" ]); then
2009-06-08 20:51:16 +00:00
# generic method (used on coreboot and ata mod)
2012-02-27 01:23:14 +00:00
uuid=
if [ x"$force_file_id" != xy ]; then
uuid="`echo "${grub_device}" | xargs "$grub_probe" --device-map="${device_map}" --target=fs_uuid --device`"
fi
2011-12-23 17:19:16 +00:00
if [ x"$disk_module" != x ] && [ x"$disk_module" != xbiosdisk ]; then
2012-02-03 09:35:28 +00:00
hints="`echo "${grub_device}" | xargs "$grub_probe" --device-map="${device_map}" --target=baremetal_hints --device`"
2012-02-27 15:06:18 +00:00
elif [ x"$grub_modinfo_platform" = xpc ]; then
2012-02-03 09:35:28 +00:00
hints="`echo "${grub_device}" | xargs "$grub_probe" --device-map="${device_map}" --target=bios_hints --device`"
2012-02-27 15:06:18 +00:00
elif [ x"$grub_modinfo_platform" = xefi ]; then
2012-02-03 09:35:28 +00:00
hints="`echo "${grub_device}" | xargs "$grub_probe" --device-map="${device_map}" --target=efi_hints --device`"
2012-02-27 15:06:18 +00:00
elif [ x"$grub_modinfo_platform" = xieee1275 ]; then
2012-02-03 09:35:28 +00:00
hints="`echo "${grub_device}" | xargs "$grub_probe" --device-map="${device_map}" --target=ieee1275_hints --device`"
2012-02-27 15:06:18 +00:00
elif [ x"$grub_modinfo_platform" = xloongson ] || [ x"$grub_modinfo_platform" = xqemu ] || [ x"$grub_modinfo_platform" = xcoreboot ] || [ x"$grub_modinfo_platform" = xmultiboot ] || [ x"$grub_modinfo_platform" = xqemu-mips ]; then
2012-02-03 09:35:28 +00:00
hints="`echo "${grub_device}" | xargs "$grub_probe" --device-map="${device_map}" --target=baremetal_hints --device`"
2011-12-23 17:19:16 +00:00
else
2012-03-02 10:53:50 +00:00
gettext "No hints available for your platform. Expect reduced performance." 1>&2
2012-02-03 21:52:23 +00:00
echo 1>&2
2011-12-23 17:19:16 +00:00
hints=
fi
2012-02-27 01:23:14 +00:00
if [ x"$uuid" != x ]; then
2012-02-27 15:06:18 +00:00
echo "search.fs_uuid ${uuid} root $hints " >> "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/load.cfg"
2012-02-27 01:23:14 +00:00
search_module=search_fs_uuid
else
mkdir -p "${grubdir}/uuid"
file="`mktemp "${grubdir}/uuid/XXXXXXXXXXXXXXXXXXXXXXXXX"`"
relfile="`${grub_mkrelpath} "$file"`"
2012-02-27 15:06:18 +00:00
echo "search.file '${relfile}' root $hints " >> "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/load.cfg"
2012-02-27 01:23:14 +00:00
search_module=search_fs_file
fi
2012-02-27 15:06:18 +00:00
echo 'set prefix=($root)'"${relative_grubdir}" >> "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/load.cfg"
config_opt="-c ${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/load.cfg "
2012-02-27 01:23:14 +00:00
modules="$modules $search_module"
2011-11-12 20:12:52 +00:00
else
2010-09-11 15:21:48 +00:00
# we need to hardcode the partition number in the core image's prefix.
2010-10-16 22:28:19 +00:00
if [ x"$grub_partition" = x ]; then
prefix_drive="()"
else
2011-12-24 01:50:30 +00:00
# Comma is already there
prefix_drive="($grub_partition)"
2010-10-16 22:28:19 +00:00
fi
2008-07-30 10:44:38 +00:00
fi
2008-06-18 17:35:26 +00:00
else
2011-08-23 09:18:00 +00:00
if [ x$GRUB_CRYPTODISK_ENABLE = xy ]; then
2012-02-03 09:35:28 +00:00
for uuid in "`echo "${grub_device}" | xargs "${grub_probe}" --target=cryptodisk_uuid --device`"; do
2012-02-27 15:06:18 +00:00
echo "cryptomount -u $uuid" >> "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/load.cfg"
2011-08-23 09:18:00 +00:00
done
2012-02-27 15:06:18 +00:00
config_opt="-c ${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/load.cfg "
2011-08-23 09:18:00 +00:00
fi
2010-11-13 15:03:29 +00:00
prefix_drive=`"$grub_probe" --device-map="${device_map}" --target=drive --device "${grub_device}"` || exit 1
2008-06-18 17:35:26 +00:00
fi
2012-02-27 15:06:18 +00:00
case "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" in
2010-04-26 19:27:41 +00:00
sparc64-ieee1275) mkimage_target=sparc64-ieee1275-raw ;;
2011-05-17 20:48:20 +00:00
mipsel-loongson) mkimage_target=mipsel-loongson-elf ;;
2012-02-27 15:06:18 +00:00
*) mkimage_target="${grub_modinfo_target_cpu}-${grub_modinfo_platform}" ;;
2010-04-26 19:27:41 +00:00
esac
2012-02-27 15:06:18 +00:00
case "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" in
2010-08-30 18:27:59 +00:00
i386-efi | x86_64-efi) imgext=efi ;;
2011-05-17 20:48:20 +00:00
mipsel-loongson | i386-coreboot | i386-multiboot | i386-ieee1275 \
2010-09-06 21:03:25 +00:00
| powerpc-ieee1275) imgext=elf ;;
2010-08-30 18:27:59 +00:00
*) imgext=img ;;
esac
2012-02-27 15:06:18 +00:00
"$grub_mkimage" ${config_opt} -d "${source_dir}" -O ${mkimage_target} --output="${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/core.${imgext}" --prefix="${prefix_drive}${relative_grubdir}" $modules || exit 1
2010-08-30 17:30:34 +00:00
2010-08-30 18:27:59 +00:00
# Backward-compatibility kludges
2012-02-27 15:06:18 +00:00
if [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "mipsel-loongson" ]; then
cp "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/core.${imgext}" "${bootdir}"/grub.elf
elif [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "i386-ieee1275" ] || [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "powerpc-ieee1275" ]; then
cp "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/core.${imgext}" "${grubdir}/grub"
elif [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "i386-efi" ] || [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "x86_64-efi" ]; then
"$grub_mkimage" ${config_opt} -d "${source_dir}" -O ${mkimage_target} --output="${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/grub.efi" --prefix="" $modules || exit 1
2010-08-30 17:30:34 +00:00
fi
2005-07-24 18:16:26 +00:00
2010-09-08 21:41:27 +00:00
2012-02-27 15:06:18 +00:00
# Perform the grub_modinfo_platform-dependent install
if [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "i386-pc" ] || [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "sparc64-ieee1275" ] ; then
2008-11-28 20:06:55 +00:00
# Now perform the installation.
2012-02-27 15:06:18 +00:00
"$grub_setup" ${allow_floppy} ${setup_verbose} ${setup_force} --directory="${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform" \
2010-11-13 15:03:29 +00:00
--device-map="${device_map}" "${install_device}" || exit 1
2012-02-27 15:06:18 +00:00
elif [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "i386-ieee1275" ] || [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = "powerpc-ieee1275" ]; then
2010-08-30 17:30:34 +00:00
if [ x"$update_nvram" = xyes ]; then
2011-01-05 00:28:28 +00:00
ofpathname="`which ofpathname`"
nvsetenv="`which nvsetenv`"
2010-11-13 15:03:29 +00:00
set "$ofpathname" dummy
2010-08-30 17:30:34 +00:00
if test -f "$1"; then
:
else
echo "$1: Not found." 1>&2
exit 1
fi
2010-11-13 15:03:29 +00:00
set "$nvsetenv" dummy
2010-08-30 17:30:34 +00:00
if test -f "$1"; then
:
else
echo "$1: Not found." 1>&2
exit 1
fi
2012-03-08 23:58:55 +00:00
if [ "${grub_modinfo_target_cpu}-${grub_modinfo_platform}" != "powerpc-ieee1275" ] \
|| [ -z "${install_device}" ]; then
# Get the Open Firmware device tree path translation.
dev="`echo $grub_device | sed -e 's/\/dev\///' -e 's/[0-9]\+//'`"
partno="`echo $grub_device | sed -e 's/.*[^0-9]\([0-9]\+\)$/\1/'`"
ofpath="`$ofpathname $dev`" || {
2012-03-05 15:42:26 +00:00
# TRANSLATORS: "device tree path" is the name of the device
# for IEEE1275
2012-03-08 23:58:55 +00:00
gettext_printf "Couldn't find IEEE1275 device tree path for %s.\nYou will have to set \`boot-device' variable manually.\n" "$dev" 1>&2
exit 1
}
2010-08-30 17:30:34 +00:00
2012-03-08 23:58:55 +00:00
# Point boot-device at the new grub install
boot_device="$ofpath:$partno,"`"$grub_mkrelpath" "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/core.${imgext}" | sed 's,/,\\\\,g'`
2012-01-23 18:33:40 +00:00
2012-03-08 23:58:55 +00:00
# If a install device is defined, copy the core.elf to PReP partition.
else
2012-01-23 18:33:40 +00:00
if [ "$("${grub_probe}" -m "${device_map}" -d "${install_device}" -t msdos_parttype)" != "41" ]; then
2012-02-03 21:52:23 +00:00
gettext "The chosen partition is not a PReP partition." 1>&2
echo 1>&2
2012-01-23 18:33:40 +00:00
exit 1
fi
if [ "$(file -s "${install_device}" -b | awk '{ print $1 }')" = ELF ] || [ $(cmp /dev/zero "${install_device}" &>/dev/null) ]; then
# Change boot device to the harddisk root
boot_device="$ofpath"
2012-02-27 15:06:18 +00:00
dd if="${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/core.${imgext}" of="${install_device}" status=noxfer || {
2012-02-03 21:52:23 +00:00
gettext "Failed to copy Grub to the PReP partition." 1>&2
echo 1>&2
2012-01-23 18:33:40 +00:00
exit 1
}
else
2012-02-03 21:52:23 +00:00
gettext "The PReP partition is not empty. If you are sure you want to use it, run dd to clear it:" 1>&2
echo 1>&2
2012-01-23 18:33:40 +00:00
echo " dd if=/dev/zero of=${install_device}"
exit 1
fi
2012-03-28 15:58:21 +00:00
dev="`echo "${install_device}" | sed -e 's/\/dev\///' -e 's/[0-9]\+//'`"
boot_device="`$ofpathname "$dev"`" || {
# TRANSLATORS: "device tree path" is the name of the device
# for IEEE1275
gettext_printf "Couldn't find IEEE1275 device tree path for %s.\nYou will have to set \`boot-device' variable manually.\n" "$dev" 1>&2
exit 1
}
2012-01-23 18:33:40 +00:00
fi
2010-08-30 17:30:34 +00:00
"$nvsetenv" boot-device "$boot_device" || {
2012-02-05 10:23:47 +00:00
# TRANSLATORS: The %s will be replaced by an external program name.
gettext_printf "\`%s' failed.\n" "$nvsetenv" 1>&2
2012-02-08 18:26:01 +00:00
gettext "You will have to set \`boot-device' variable manually. At the IEEE1275 prompt, type:" 1>&2
2012-02-03 21:52:23 +00:00
echo 1>&2
echo " setenv boot-device $boot_device" 1>&2
2010-08-30 17:30:34 +00:00
exit 1
}
fi
2012-02-27 15:06:18 +00:00
elif [ x"${grub_modinfo_target_cpu}-${grub_modinfo_platform}" = xmips-arc ]; then
dvhtool -d "${install_device}" --unix-to-vh "{grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/core.${imgext}" grub
2012-03-02 10:53:50 +00:00
gettext "You will have to set \`SystemPartition' and \`OSLoader' manually." 1>&2
2012-02-03 21:52:23 +00:00
echo 1>&2
2012-02-27 15:06:18 +00:00
elif [ x"$grub_modinfo_platform" = xefi ]; then
cp "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/core.${imgext}" "${efidir}/${efi_file}"
2011-03-29 22:05:25 +00:00
# For old macs. Suggested by Peter Jones.
2012-02-27 15:06:18 +00:00
if [ x$grub_modinfo_target_cpu = xi386 ]; then
cp "${grubdir}/${grub_modinfo_target_cpu}-$grub_modinfo_platform/core.${imgext}" "${efidir}/boot.efi"
2011-03-29 22:05:25 +00:00
fi
2010-09-08 11:54:38 +00:00
2010-08-30 19:00:48 +00:00
# Try to make this image bootable using the EFI Boot Manager, if available.
2011-01-05 00:28:28 +00:00
efibootmgr="`which efibootmgr`"
2010-08-30 19:00:48 +00:00
if test "$removable" = no && test -n "$efi_distributor" && \
test -n "$efibootmgr"; then
# On Linux, we need the efivars kernel modules.
case "$host_os" in
linux*)
modprobe -q efivars 2>/dev/null || true ;;
esac
# Delete old entries from the same distributor.
for bootnum in `efibootmgr | grep '^Boot[0-9]' | \
2010-09-08 12:07:21 +00:00
fgrep -i " $efi_distributor" | cut -b5-8`; do
2010-08-30 19:00:48 +00:00
efibootmgr $efi_quiet -b "$bootnum" -B
done
# Add a new entry for the image we just created. efibootmgr needs to be
# given the disk device and partition number separately, so we have to
# fiddle about with grub-probe to get hold of this reasonably reliably.
# Use fresh device map text to avoid any problems with stale data, since
# all we need here is a one-to-one mapping.
2012-02-03 21:36:51 +00:00
efidir_drive="$("$grub_probe" --target=drive --device-map= "$efidir")"
efidir_disk="$("$grub_probe" --target=disk --device-map= "$efidir")"
if test -z "$efidir_drive" || test -z "$efidir_disk"; then
2012-02-03 21:52:23 +00:00
gettext_printf "Can't find GRUB drive for %s; unable to create EFI Boot Manager entry.\n" "$efidir" >&2
2010-08-30 19:00:48 +00:00
else
efidir_part="$(echo "$efidir_drive" | sed 's/^([^,]*,[^0-9]*//; s/[^0-9].*//')"
efibootmgr $efi_quiet -c -d "$efidir_disk" -p "$efidir_part" -w \
2011-01-03 13:33:43 +00:00
-L "$bootloader_id" -l "\\EFI\\$efi_distributor\\$efi_file"
2010-08-30 19:00:48 +00:00
fi
fi
2012-01-25 14:06:27 +00:00
else
2012-02-03 21:52:23 +00:00
gettext "WARNING: no platform-specific install was performed" 1>&2
echo 1>&2
2008-11-28 20:06:55 +00:00
fi
2005-07-24 18:16:26 +00:00
2012-02-03 21:52:23 +00:00
gettext "Installation finished. No error reported." 1>&2
echo 1>&2
2005-07-24 18:16:26 +00:00
# Bye.
exit 0